.586    
.model flat,stdcall
option casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD
EnumProc    PROTO   :DWORD,:DWORD

include \masm32\macros\ucmacros.asm

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\comctl32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\comctl32.lib

.const

MainWindowWidth     equ     600
MainWindowHeight    equ     350

.data

hInstance       dd      ?
hMainWindow     dd      ?
WSTR            MainWindowClass,    "MainWindowClass"
WSTR            MainWindowName,     "List View Animate Example"
MWN             db      sizeof MainWindowName
wc              WNDCLASSEX          <sizeof wc,CS_HREDRAW+CS_VREDRAW,offset WndProc,NULL,NULL,NULL,\
                                   NULL,NULL,COLOR_WINDOW,NULL,offset MainWindowClass,NULL>
hLV             dd      ?
WSTR            ListViewClass,"SysListView32"
lvc             LV_COLUMN       <>
lvi             LV_ITEM         <>
WSTR            szWindowName,"Window Name"
WSTR            szClassName,"Class Name"
WSTR            szHandle,"hWnd"
TextBuffer      WCHAR   128 dup(0)

rect            RECT        <>
iccx            INITCOMMONCONTROLSEX    <sizeof iccx,ICC_STANDARD_CLASSES+ICC_LISTVIEW_CLASSES+ICC_WIN95_CLASSES>                                   
wcex            WNDCLASSEX          <sizeof wcex,<>>
wcs             WNDCLASS            <sizeof wcs,<>>
hList           dd          ?

.code
    start:
        invoke  GetModuleHandle,NULL
        mov     hInstance,eax
        invoke  InitCommonControlsEx,addr iccx
        invoke  WinMain,hInstance,NULL,NULL,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInstance
    pop     wc.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassExW,addr wc
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CharToOemW,addr MainWindowName,addr MWN
    invoke  CreateWindowExW,NULL,addr MainWindowClass,addr MWN,WS_TILEDWINDOW,\   
               eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,hMainWindow,CmdShow
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessageW,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessageW,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    local   lpOldWndProc:DWORD
    
    .if uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL
        
    .elseif	uMsg==WM_CREATE
		mov		edi,lParam
		.if	[edi.CREATESTRUCT].hWndParent==NULL
                invoke  GetClientRect,hWnd,addr rect
                invoke  CreateWindowExW,NULL,addr ListViewClass,NULL,WS_VISIBLE+WS_CHILD+LVS_REPORT,\
                        0,0,rect.right,rect.bottom,hWnd,NULL,hInstance,NULL
                mov     hLV,eax
                invoke  ImageList_Create,16,16,ILC_COLOR32+ILC_MASK,100,100
                mov     hList,eax
                invoke  SendMessageW,hLV,LVM_SETIMAGELIST,LVSIL_SMALL,hList
                shr     rect.right,1
                push    rect.right
                pop     lvc.lx
                mov     lvc.pszText,offset szWindowName
                mov     lvc.imask,LVCF_WIDTH+LVCF_TEXT
                invoke  SendMessage,hLV,LVM_INSERTCOLUMNW,0,addr lvc
                shr     lvc.lx,1
                mov     lvc.pszText,offset szClassName
                invoke	SendMessage,hLV,LVM_INSERTCOLUMNW,1,addr lvc
                sub     lvc.lx,2
                mov     lvc.pszText,offset szHandle
                invoke  SendMessage,hLV,LVM_INSERTCOLUMNW,2,addr lvc
                invoke  EnumWindows,addr EnumProc,NULL
            .endif	        	
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor eax,eax
    ret

WndProc     endp

EnumProc    PROC    hWnd:DWORD,lParam:DWORD

    invoke  GetWindowTextW,hWnd,addr TextBuffer,sizeof TextBuffer
    mov     lvi.imask,LVIF_TEXT+LVIF_IMAGE
    mov     lvi.iSubItem,0
    mov     lvi.pszText,offset TextBuffer
    invoke  GetClassLong,hWnd,GCL_HICON
    .if     eax!=0
        invoke  ImageList_AddIcon,hList,eax
        mov     lvi.iImage,eax                                                
        invoke  SendMessage,hLV,LVM_INSERTITEMW,0,addr lvi
        invoke  GetClassNameW,hWnd,addr TextBuffer,sizeof TextBuffer
        inc     lvi.iSubItem
        invoke  SendMessage,hLV,LVM_SETITEMW,0,addr lvi
        inc     lvi.iItem
    .endif
    mov     eax,1
    ret

EnumProc    endp
end	start